//This isn't stealing, is it?
freeslot("MT_CLONE")

//Starting from Scratch
addHook("ThinkFrame", do
	for player in players.iterate
//Start Section: Clone
		if (player.mo and player.mo.skin == "clonemiles")
	//Start Subsection: Pre-Setup
		//This is the Original Character
			player.cskin = "tails"

		//This is our Current Player
			player.pskin = "clonemiles"
			
		//For adding a Spindash to Amy/Fang
			player.spskin = "tails"
	//End Subsection: Pre-Setup

	//Start Subsection: Initialization
		//Setup the Clone
			if not (player.clone and player.clone.valid)
				player.clone = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z, MT_CLONE)
				player.clone.skin = player.cskin
			end
			
		//Copy the Player attributes to the Clone
			player.clone.scale = player.mo.scale
			player.clone.angle = player.drawangle
			player.clone.flags2 = player.mo.flags2
			player.clone.eflags = player.mo.eflags
			player.clone.flags = $|MF_NOGRAVITY
			player.clone.rollangle = player.mo.rollangle
			player.clone.tics = player.mo.tics
	//End Subsection: Initialization
	
	//Start Subsection: Rolling
		//Spindashing
			if (player.pflags & PF_STARTDASH)
				player.clone.skin = player.spskin
			else
				player.clone.skin = player.cskin
			end
		
		//Stay Curled
			if (player.pflags & PF_SPINNING)
			and not (player.pflags & PF_STARTDASH)
				player.mo.state = S_PLAY_ROLL
			end
			
		//Remove the Spin Trail when using Abilities
			if (player.panim == PA_ABILITY)
				player.spinitem = MT_NULL
			else
				player.spinitem = MT_THOK
			end
	//End Subsection: Rolling

	//Start Subsection: Clone Movement
		//Copy the Player State
			if (player.clone.state != player.mo.state)
			and not (player.panim == PA_JUMP)
			and not (player.mo.state == S_PLAY_SWIM)
			//Separating this for readability
			and not (skins[player.cskin].followitem == MT_TAILSOVERLAY
			and (player.mo.state == S_PLAY_FLY or player.mo.state == S_PLAY_RUN))
			//If player should be tails, double walk speed and swim
				player.clone.state = player.mo.state
			elseif (player.mo.state == S_PLAY_FLY)
			and (player.clone.state != S_PLAY_SWIM)
				player.clone.state = S_PLAY_SWIM
			elseif (player.mo.state == S_PLAY_RUN)
			and (skins[player.cskin].followitem == MT_TAILSOVERLAY)
				player.clone.state = S_PLAY_WALK
			elseif (player.mo.state == S_PLAY_SWIM)
				if (skins[player.cskin].flags & SF_FASTEDGE)
					player.clone.state = S_PLAY_EDGE
				else
					if not (player.clone.state == S_PLAY_SWIM)
						player.clone.state = S_PLAY_SWIM
					end
				end
			elseif (player.panim == PA_JUMP)
				if (skins[player.mo.skin].flags & SF_NOJUMPSPIN)
					if not (player.clone.state == S_PLAY_SPRING)
					and not (player.clone.state == S_PLAY_FALL)
						player.clone.state = S_PLAY_SPRING
					end
				else
					if not (player.clone.state == S_PLAY_ROLL)
						player.clone.state = S_PLAY_ROLL
					end
				end
			end
			
		//Skidding?
			if (player.skidtime > 0)
				player.clone.frame = player.mo.frame
			end
		
		//Movement
			if (player.mo.eflags & MFE_VERTICALFLIP)
			//Not fully working
				if (player.pflags & PF_STARTDASH)
				or (player.pflags & PF_JUMPED)
				or (player.mo.state == S_PLAY_FLY)
				or ((player.mo.state == S_PLAY_ROLL) and (P_IsObjectOnGround(player.mo)))
					P_TeleportMove(player.clone, player.mo.x, player.mo.y, player.mo.z+(30*player.mo.scale))
				else
					P_TeleportMove(player.clone, player.mo.x, player.mo.y, player.mo.z+(50*player.mo.scale))
				end
			else
				P_TeleportMove(player.clone, player.mo.x, player.mo.y, player.mo.z)
			end
	//End Subsection: Clone Movement
	
	//Start Subsection: Color
		//Coloring with a hint of Dash Mode
		if (player.dashmode > 3*TICRATE)
			if (player.charflags & SF_MACHINE)
			and (player.skincolor != SKINCOLOR_KETCHUP)
				if not (player.clone.color == SKINCOLOR_KETCHUP)
					player.clone.color = SKINCOLOR_KETCHUP
				else
					player.clone.color = player.mo.color
				end
			else
				player.clone.colorized = not $
			end
		else
			player.clone.color = player.skincolor
			if (player.color != player.skincolor)
				player.clone.color = player.mo.color
			end
			player.clone.colorized = player.mo.colorized
		end
	//End Subsection: Color
//End Section: Clone

//Start Section: NiGHTs
		elseif (player.powers[pw_carry] == CR_NIGHTSMODE)
		and (player.cskin != nil)
		//NiGHTs skins are back!
			player.mo.skin = player.cskin
			player.mo.color = player.skincolor
//End Section: NiGHTs

//Start Section: Removal
		else
			if (player.clone and player.clone.valid)
			and(player.mo.skin != player.pskin)
				P_RemoveMobj(player.clone)
			end
		end
//End Section: Removal
		
	end
end)